"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.analyticsNode = exports.post = void 0;
var tslib_1 = require("tslib");
var node_fetch_1 = tslib_1.__importDefault(require("node-fetch"));
var package_json_1 = require("../../package.json");
var btoa = function (val) { return Buffer.from(val).toString('base64'); };
function post(event, writeKey) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var res;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, node_fetch_1.default)("https://api.segment.io/v1/".concat(event.type), {
                        method: 'POST',
                        headers: {
                            'Content-Type': 'application/json',
                            'User-Agent': 'analytics-node-next/latest',
                            Authorization: "Basic ".concat(btoa(writeKey)),
                        },
                        body: JSON.stringify(event),
                    })];
                case 1:
                    res = _a.sent();
                    if (!res.ok) {
                        throw res;
                    }
                    return [2 /*return*/, event];
            }
        });
    });
}
exports.post = post;
function analyticsNode(settings, analytics) {
    var _this = this;
    var send = function (ctx) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
        var err_1;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    ctx.updateEvent('context.library.name', 'analytics-node-next');
                    ctx.updateEvent('context.library.version', package_json_1.version);
                    ctx.updateEvent('_metadata.nodeVersion', process.versions.node);
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, post(ctx.event, settings.writeKey)];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    err_1 = _a.sent();
                    analytics.emit('error', {
                        ctx: ctx,
                        code: 'http_delivery',
                        message: 'there was an error sending the event to segment',
                        response: err_1,
                    });
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/, ctx];
            }
        });
    }); };
    return {
        name: 'analytics-node-next',
        type: 'after',
        version: '1.0.0',
        load: function (ctx) { return Promise.resolve(ctx); },
        isLoaded: function () { return true; },
        track: send,
        identify: send,
        page: send,
        alias: send,
        group: send,
        screen: send,
    };
}
exports.analyticsNode = analyticsNode;
//# sourceMappingURL=plugin.js.map